# Experiment with Apache Kafka and streaming framework

Mesure latency between record insertion in Kafka and Streaming processing using Kafka automated timestamp of messages.

##Frameworks tested
- Kafka Stream
- Flink
- Spark (streaming, Structured Streaming and Continuous Processing

##Versions
- Spark : 2.3.0
- Flink : 1.4.2
- Kafka : 0.11.0.2

##Sources
###Producer
- fr.ippon.kafkaLatency.AlimKafka : Kafka Producer (100 000 messages)

###Consummer
 fr.ippon.kafkaLatency.streaming.KafkaSpark : Spark streaming consummer
 fr.ippon.kafkaLatency.streaming.KafkaStructuredSpark : Spark Structured streaming consummer
 fr.ippon.kafkaLatency.streaming.KafkaContinuousSpark : Spark Continous processing consummer
 fr.ippon.kafkaLatency.streaming.KafkaStreaming : Kafka Streams consummer
 fr.ippon.kafkaLatency.streaming.KafkaFlink : Flink consummer

###Utils
 fr.ippon.kafkaLatency.utils.UtilStats : Streaming statistics
 fr.ippon.kafkaLatency.utils.MetricsProducerReporter : Kafka Producer Metrics

##Resources
###config.properties :
 - Kafka
    - topic : Kafka topic name to use
    - numPartitions : Number of partitions for topic
    - replication : Replication Factor for topic
    - bootstrap.servers: List of Kafka servers

 - Streaming
    - stats.step=1000
    - stats.total=100000
    - max.poll.records=1000
    - spark.continuous.interval=300
    - spark.structured.interval=150
    - spark.streaming.interval=50

 - data source
    - listPersonns.json





